#import "~/graphql_shared/fragments/label.fragment.graphql"
#import "~/graphql_shared/fragments/user.fragment.graphql"
#import "~/work_items/graphql/milestone.fragment.graphql"
#import "~/work_items/graphql/timelog.fragment.graphql"
#import "./rolledup_dates.fragment.graphql"

fragment WorkItemWidgets on WorkItemWidget {
  type
  ... on WorkItemWidgetDescription {
    description
    descriptionHtml
    lastEditedAt
    lastEditedBy {
      name
      webPath
    }
    taskCompletionStatus {
      completedCount
      count
    }
  }
  ... on WorkItemWidgetAssignees {
    allowsMultipleAssignees
    canInviteMembers
    assignees {
      nodes {
        ...User
      }
    }
  }
  ... on WorkItemWidgetLabels {
    allowsScopedLabels
    labels {
      nodes {
        ...Label
      }
    }
  }
  ... on WorkItemWidgetStartAndDueDate {
    dueDate
    startDate
  }
  ... on WorkItemWidgetTimeTracking {
    timeEstimate
    timelogs {
      nodes {
        ...TimelogFragment
      }
    }
    totalTimeSpent
  }
  ...RolledupDatesFragment
  ... on WorkItemWidgetWeight {
    weight
    rolledUpWeight
    rolledUpCompletedWeight
    widgetDefinition {
      editable
      rollUp
    }
  }
  ... on WorkItemWidgetProgress {
    progress
    updatedAt
  }
  ... on WorkItemWidgetHierarchy {
    hasChildren
    hasParent
    parent {
      id
      iid
      title
      confidential
      webUrl
      workItemType {
        id
        name
        iconName
      }
    }
  }
  ... on WorkItemWidgetIteration {
    iteration {
      description
      id
      iid
      title
      startDate
      dueDate
      webUrl
      updatedAt
      iterationCadence {
        id
        title
      }
    }
  }
  ... on WorkItemWidgetMilestone {
    milestone {
      ...MilestoneFragment
    }
  }
  ... on WorkItemWidgetNotes {
    discussionLocked
  }
  ... on WorkItemWidgetHealthStatus {
    healthStatus
  }
  ... on WorkItemWidgetNotifications {
    subscribed
  }
  ... on WorkItemWidgetCurrentUserTodos {
    currentUserTodos(state: pending) {
      nodes {
        id
      }
    }
  }

  ... on WorkItemWidgetColor {
    color
    textColor
  }

  ... on WorkItemWidgetDevelopment {
    type
    willAutoCloseByMergeRequest
    closingMergeRequests {
      nodes {
        fromMrDescription
        mergeRequest {
          iid
          id
          title
          webUrl
          state
          project {
            id
            name
            namespace {
              path
            }
          }
          assignees {
            nodes {
              webUrl
              id
              name
              webPath
              avatarUrl
            }
          }
        }
      }
    }
  }

  ... on WorkItemWidgetCrmContacts {
    contacts {
      nodes {
        id
        email
        firstName
        lastName
        phone
        description
        organization {
          id
          name
          description
          defaultRate
        }
      }
    }
  }
}
